#!/bin/bash
export user_home=$(eval echo ~${SUDO_USER})
if [ "$(pwd)" = "/" ]; then
	if [ "$(which thunar 2>/dev/null)" ] || [ "$(which Thunar 2>/dev/null)" ]; then
		CONFIG="$user_home/.config/Thunar/uca.xml"
		CONFIG_BAK="$user_home/.config/Thunar/uca.xml.bak"
		CONFIG_TMP="/tmp/uca.xml"
		ICON="sfsload"
		NAME="Load SFS"
		DESC="Load SFS"
		CMD="go_loadmodule %f"
		EXTENSIONS="*.sfs;*.squashfs"
		if [ -f "$CONFIG" ]; then
			grep "<name>${NAME}</name>" "$CONFIG" >/dev/null || {
			grep -v '^</actions>' "$CONFIG" > "$CONFIG_TMP"
			echo '<action>
	<icon>'${ICON}'</icon>
	<name>'${NAME}'</name>
	<command>'${CMD}'</command>
	<description>'${DESC}'</description>
	<patterns>'${EXTENSIONS}'</patterns>
	<other-files/>
</action>
</actions>' >> "$CONFIG_TMP"
			mv "$CONFIG" "$CONFIG_BAK"
			mv "$CONFIG_TMP" "$CONFIG"
		}
		else
			mkdir -p "${CONFIG%/*}"
			echo '<?xml encoding="UTF-8" version="1.0"?>
<actions>
<action>
	<icon>'${ICON}'</icon>
	<name>'${NAME}'</name>
	<command>'${CMD}'</command>
	<description>'${DESC}'</description>
	<patterns>'${EXTENSIONS}'</patterns>
	<other-files/>
</action>
</actions>' > "$CONFIG" 
		fi
		ICON="sfsload"
		NAME="Unload SFS"
		DESC="Unload SFS"
		CMD="go_unloadmodule %f"
		EXTENSIONS="*.sfs;*.squashfs"
	grep "<name>${NAME}</name>" "$CONFIG" >/dev/null || {
			grep -v '^</actions>' "$CONFIG" > "$CONFIG_TMP"
			echo '<action>
	<icon>'${ICON}'</icon>
	<name>'${NAME}'</name>
	<command>'${CMD}'</command>
	<description>'${DESC}'</description>
	<patterns>'${EXTENSIONS}'</patterns>
	<other-files/>
</action>
</actions>' >> "$CONFIG_TMP"
			mv "$CONFIG" "$CONFIG_BAK"
			mv "$CONFIG_TMP" "$CONFIG"
		}
		ICON="sfsload"
		NAME="Create SFS"
		DESC="Create SFS"
		CMD="cr-sfs %f"
		EXTENSIONS="*"
	grep "<name>${NAME}</name>" "$CONFIG" >/dev/null || {
			grep -v '^</actions>' "$CONFIG" > "$CONFIG_TMP"
			echo '<action>
	<icon>'${ICON}'</icon>
	<name>'${NAME}'</name>
	<command>'${CMD}'</command>
	<description>'${DESC}'</description>
	<patterns>'${EXTENSIONS}'</patterns>
	<directories/>
</action>
</actions>' >> "$CONFIG_TMP"
			mv "$CONFIG" "$CONFIG_BAK"
			mv "$CONFIG_TMP" "$CONFIG"
		}
		ICON="gdmap_icon"
		NAME="Graphical Disk Map"
		DESC="Graphical Disk Map"
		CMD="gdmap -f %f"
		EXTENSIONS="*"
	grep "<name>${NAME}</name>" "$CONFIG" >/dev/null || {
			grep -v '^</actions>' "$CONFIG" > "$CONFIG_TMP"
			echo '<action>
	<icon>'${ICON}'</icon>
	<name>'${NAME}'</name>
	<command>'${CMD}'</command>
	<description>'${DESC}'</description>
	<patterns>'${EXTENSIONS}'</patterns>
	<directories/>
</action>
</actions>' >> "$CONFIG_TMP"
			mv "$CONFIG" "$CONFIG_BAK"
			mv "$CONFIG_TMP" "$CONFIG"
		}
		ICON="video-x-generic"
		NAME="Convert to animated gif"
		DESC="Convert short video to animated gif"
		CMD="gifenc %f"
		EXTENSIONS="*"
	grep "<name>${NAME}</name>" "$CONFIG" >/dev/null || {
			grep -v '^</actions>' "$CONFIG" > "$CONFIG_TMP"
			echo '<action>
	<icon>'${ICON}'</icon>
	<name>'${NAME}'</name>
	<command>'${CMD}'</command>
	<description>'${DESC}'</description>
	<patterns>'${EXTENSIONS}'</patterns>
	<video-files/>
</action>
</actions>' >> "$CONFIG_TMP"
			mv "$CONFIG" "$CONFIG_BAK"
			mv "$CONFIG_TMP" "$CONFIG"
		}
		ICON="xbpstools"
		NAME="Create xbps package"
		DESC="Create xbps package from directory"
		CMD="dir2xbps %f"
		EXTENSIONS="*"
	grep "<name>${NAME}</name>" "$CONFIG" >/dev/null || {
			grep -v '^</actions>' "$CONFIG" > "$CONFIG_TMP"
			echo '<action>
	<icon>'${ICON}'</icon>
	<name>'${NAME}'</name>
	<command>'${CMD}'</command>
	<description>'${DESC}'</description>
	<patterns>'${EXTENSIONS}'</patterns>
	<directories/>
</action>
</actions>' >> "$CONFIG_TMP"
			mv "$CONFIG" "$CONFIG_BAK"
			mv "$CONFIG_TMP" "$CONFIG"
		}
		ICON="file_mnt"
		NAME="File Mount (iso sfs squashfs 4fs ...)"
		DESC="File Mount (iso sfs squashfs 4fs ...)"
		CMD="filemnt-thunar %f"
		EXTENSIONS="*.iso;*.ISO;*.sfs;*.SFS;*.squashfs;*.xzm;*.2fs;*.3fs;*.4fs"
	grep "<name>${NAME}</name>" "$CONFIG" >/dev/null || {
			grep -v '^</actions>' "$CONFIG" > "$CONFIG_TMP"
			echo '<action>
	<icon>'${ICON}'</icon>
	<name>'${NAME}'</name>
	<command>'${CMD}'</command>
	<description>'${DESC}'</description>
	<patterns>'${EXTENSIONS}'</patterns>
	<other-files/>
</action>
</actions>' >> "$CONFIG_TMP"
			mv "$CONFIG" "$CONFIG_BAK"
			mv "$CONFIG_TMP" "$CONFIG"
		}
	fi
fi
